glibmm 2.88.0

Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Related Symbols | List of all members
Gio::SocketControlMessage Class Reference
Portable Network I/O Functionality

A Socket control message. More...

`#include <giomm/socketcontrolmessage.h>`

Inheritance diagram for Gio::SocketControlMessage:
[legend]

## Public Member Functions
| SocketControlMessage (SocketControlMessage &&src) noexcept
SocketControlMessage & | operator= (SocketControlMessage &&src) noexcept
| ~SocketControlMessage () noexcept override
GSocketControlMessage * | gobj ()
| Provides access to the underlying C GObject.
const GSocketControlMessage * | gobj () const
| Provides access to the underlying C GObject.
GSocketControlMessage * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_level () const
| Returns the "level" (i.e. the originating protocol) of the control message.
int | get_msg_type () const
| Returns the protocol specific type of the control message.
gsize | get_size () const
| Returns the space required for the control message, not including headers or alignment.
void | serialize (gpointer data)
| Converts the data in the message to bytes placed in the message.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SocketControlMessage > | deserialize (int level, int type, gsize size, gpointer data)
| Tries to deserialize a socket control message of a given level and type.

## Protected Types
using | DeserializeFunc = Glib::RefPtr< SocketControlMessage >(*)(int level, int type, gsize size, gpointer data)
| Pointer to a function that can be called from deserialize() or g_socket_control_message_deserialize().

## Protected Member Functions
| SocketControlMessage ()
virtual gsize | get_size_vfunc () const
virtual int | get_level_vfunc () const
virtual int | get_type_vfunc () const
virtual void | serialize_vfunc (gpointer data)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Static Protected Member Functions
static void | add_deserialize_func (DeserializeFunc func)
| Register a deserialize function.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::SocketControlMessage > | wrap (GSocketControlMessage *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Socket control message.

A SocketControlMessage is a special-purpose utility message that can be sent to or received from a Socket. These types of messages are often called "ancillary data".

The message can represent some sort of special instruction to or information from the socket or can represent a special kind of transfer to the peer (for example, sending a file description over a UNIX socket).

These messages are sent with Gio::Socket::send() and received with Gio::Socket::receive().

To extend the set of control message that can be sent, subclass this class and override the get_size_vfunc(), get_level_vfunc(), get_type_vfunc() and serialize_vfunc() methods.

To extend the set of control messages that can be received, subclass this class and implement a DeserializeFunc function. Typically it would be a static class method. Also, make sure you register the DeserializeFunc function with a call to add_deserialize_func() before calling Gio::Socket::receive() to read such a message.

Since glibmm 2.28:

## Member Typedef Documentation

## ◆ DeserializeFunc

using Gio::SocketControlMessage::DeserializeFunc = Glib::RefPtr<SocketControlMessage> (*) (int level, int type, gsize size, gpointer data)
| protected

Pointer to a function that can be called from deserialize() or g_socket_control_message_deserialize().

For instance,

Glib::RefPtr<SocketControlMessage> my_deserialize_func(
int level, int type, gsize size, gpointer data);
size
valarray< size_t > size() const
std::shared_ptr

Parameters

  level | A socket level.
  type | A socket control message type for the given level.
  size | The size of the data in bytes.
  data | Pointer to the message data (element-type guint8).

Returns
  The deserialized message or an empty Glib::RefPtr. The returned message can be a subclass of SocketControlMessage.

## Constructor & Destructor Documentation

## ◆ SocketControlMessage() [1/2]

Gio::SocketControlMessage::SocketControlMessage | ( | SocketControlMessage && | src | ) |
| noexcept

## ◆ ~SocketControlMessage()

Gio::SocketControlMessage::~SocketControlMessage | ( |  | ) |
| override noexcept

## ◆ SocketControlMessage() [2/2]

Gio::SocketControlMessage::SocketControlMessage | ( |  | ) |
| protected

## Member Function Documentation

## ◆ add_deserialize_func()

static void Gio::SocketControlMessage::add_deserialize_func | ( | DeserializeFunc | func | ) |
| static protected

Register a deserialize function.

If the same function is registered multiple times, only the first registration has an effect.

In GLib, deserialize() is a class virtual function (not associated with an instance). Such functions don't exist in C++. A function registered with add_deserialize_func() is a kind of replacement.

## ◆ deserialize()

static Glib::RefPtr< SocketControlMessage > Gio::SocketControlMessage::deserialize | ( | int | level,
|  | int | type,
|  | gsize | size,
|  | gpointer | data
| ) |  |
| static

Tries to deserialize a socket control message of a given level and type.

This will ask all known (to GType) subclasses of SocketControlMessage if they can understand this kind of message and if so deserialize it into a SocketControlMessage.

If there is no implementation for this kind of control message, `nullptr` will be returned.

Since glibmm 2.22:

Parameters

  level | A socket level.
  type | A socket control message type for the given level.
  size | The size of the data in bytes.
  data | Pointer to the message data.

Returns
  The deserialized message or `nullptr`.

## ◆ get_level()

int Gio::SocketControlMessage::get_level | ( |  | ) | const

Returns the "level" (i.e. the originating protocol) of the control message.

This is often SOL_SOCKET.

Since glibmm 2.22:

Returns
  An integer describing the level.

## ◆ get_level_vfunc()

virtual int Gio::SocketControlMessage::get_level_vfunc | ( |  | ) | const
| protected virtual

## ◆ get_msg_type()

int Gio::SocketControlMessage::get_msg_type | ( |  | ) | const

Returns the protocol specific type of the control message.

For instance, for UNIX fd passing this would be SCM_RIGHTS.

Since glibmm 2.22:

Returns
  An integer describing the type of control message.

## ◆ get_size()

gsize Gio::SocketControlMessage::get_size | ( |  | ) | const

Returns the space required for the control message, not including headers or alignment.

Since glibmm 2.22:

Returns
  The number of bytes required.

## ◆ get_size_vfunc()

virtual gsize Gio::SocketControlMessage::get_size_vfunc | ( |  | ) | const
| protected virtual

## ◆ get_type()

static GType Gio::SocketControlMessage::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_type_vfunc()

virtual int Gio::SocketControlMessage::get_type_vfunc | ( |  | ) | const
| protected virtual

## ◆ gobj() [1/2]

GSocketControlMessage * Gio::SocketControlMessage::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GSocketControlMessage * Gio::SocketControlMessage::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GSocketControlMessage * Gio::SocketControlMessage::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SocketControlMessage & Gio::SocketControlMessage::operator= | ( | SocketControlMessage && | src | ) |
| noexcept

## ◆ serialize()

void Gio::SocketControlMessage::serialize | ( | gpointer | data | ) |

Converts the data in the message to bytes placed in the message.

data is guaranteed to have enough space to fit the size returned by g_socket_control_message_get_size() on this object.

Since glibmm 2.22:

Parameters

  data | A buffer to write data to.

## ◆ serialize_vfunc()

virtual void Gio::SocketControlMessage::serialize_vfunc | ( | gpointer | data | ) |
| protected virtual

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::SocketControlMessage > wrap | ( | GSocketControlMessage * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.